public class LineInput{
  public static final int OK         =0;
  public static final int STRINGERROR=0x80000000;
  public static final int DOUBLEERROR=2;
  public static final int FLOATERROR =3;
  public static final int LONGERROR  =4;
  public static final int INTERROR   =5;
  
  private static String errmsg="";
  private static int status;
  
  public static String lastError(){return errmsg;}
  
  public static String readString(){
    status=OK;
    java.io.BufferedReader rein=new java.io.BufferedReader(new java.io.InputStreamReader(System.in));
    String st;
    try{
      st=rein.readLine();
    }catch (java.io.IOException e){
      st="";//leerer String im Fehlerfall
      errmsg="Fehler beim Einlesen eines Strings";
      status=STRINGERROR;
    }
    return st;
  }

  public static double readDouble(){
    String st=readString();
    try{
      return Double.parseDouble(st);
    }catch (NumberFormatException e){
      errmsg="Ungltige Fliekommazahl";
      status=DOUBLEERROR;
      return 0;//im Fehlerfall wird die Eingabe als 0 interpretiert
    }
  }
  public static float readFloat(){
    if(status==DOUBLEERROR) status=FLOATERROR;
    return (float)readDouble();  
  }

  public static long readLong(){
    String st=readString();
    try{
      return Long.parseLong(st);
    }catch (NumberFormatException e){
      errmsg="Ungltige Ganzzahl";
      status=LONGERROR;
      return 0;//im Fehlerfall wird die Eingabe als 0 interpretiert
    }
  }
  public static int readInt(){
    if(status==LONGERROR) status=INTERROR;
    return (int)readLong();
  }
  
  public static void main(String[] args){
    String s=readString(); System.out.println(s);
    int    i=readInt();    System.out.println(i);
    long   l=readLong();   System.out.println(l);
    float  f=readFloat();  System.out.println(f);
    double d=readDouble(); System.out.println(d);
  }
}
