import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class KrugSpiel extends JFrame implements ActionListener{
  Krug[] ist;              //die Krge in ihrem jeweils aktuellen Zustand
  double[] merk;           //merkt sich die anfnglichen Fllungen
  double[] soll;           //die Fllungen, die erreicht werden sollen
  int anzahl;              //die Anzahl der gemachten Zge
  JLabel fortschrittLabel; //der Text in der Statuszeile
  JLabel anzahlLabel;      //die Zahl daneben
  JButton[][] gieen;      //zweidimensionales Array von JButtons
  JLabel[] sollLabel;      //die letzte Spalte mit der Anzeige von soll
  JButton reset;           //fr die Wiederherstellung des Anfangszustands
  private static final String L_WEITER="Anzahl der Zge:";
  private static final String L_FERTIG="Geschafft! "+L_WEITER;

  public KrugSpiel(Krug[] start, double[] soll){
    super("Krugspiel");
    this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    this.ist=start;
    int anz=start.length;
    merk=new double[anz];
    for(int i=0; i<anz; i++) merk[i]=start[i].getFllung();
    this.soll=soll;
    Container c=this.getContentPane();//hat BorderLayout
    //erzeuge den Reset-Button
    reset=new JButton("Startsituation");
    reset.addActionListener(this);
    c.add(reset, BorderLayout.NORTH);
    //erzeuge die Anzeige der bentigten Schritte
    JPanel p;
    p=new JPanel();//FlowLayout ist Default
    fortschrittLabel=new JLabel();
    p.add(fortschrittLabel);
    anzahlLabel=new JLabel();
    p.add(anzahlLabel);
    c.add(p, BorderLayout.SOUTH);
    //Erzeuge die Matrix
    p=new JPanel(new GridLayout(anz, anz+1));
    c.add(p, BorderLayout.CENTER);
    gieen=new JButton[anz][anz];
    sollLabel=new JLabel[anz];
    for(int zeile=0; zeile<anz; zeile++){
      for(int spalte=0; spalte<anz; spalte++){
        JButton b=new JButton();
        b.addActionListener(this);
        p.add(b);
        gieen[zeile][spalte]=b;
      }
      sollLabel[zeile]=new JLabel();
      sollLabel[zeile].setHorizontalAlignment(JLabel.CENTER);
      p.add(sollLabel[zeile]);
    }
    reset();
    pack();
    show();
  }

  public void reset(){
    int anz=ist.length;
    if(anz!=soll.length) soll=new double[anz];
    for(int i=0; i<anz; i++){
      if(soll[i]<0 || soll[i]>ist[i].getVolumen())
        soll[i]=ist[i].getFllung();
      ist[i].setFllung(merk[i]);
      sollLabel[i].setText(String.valueOf(soll[i]));
      setAnzeigeText(i);
    }
    anzahl=0;
    anzahlLabel.setText("0");
    fortschrittLabel.setText(L_WEITER);
  }

  public void actionPerformed(ActionEvent e){
    Object button=e.getSource();
    if(button==reset) {reset(); return;}
    int anz=ist.length;
    int zeile, spalte=0;
    such: for(zeile=0; zeile<anz; zeile++)
      for(spalte=0; spalte<anz; spalte++)
        if(button==gieen[zeile][spalte]) break such;
    if(zeile<anz && spalte<anz){
      ist[zeile].schtteIn(ist[spalte]);
      setAnzeigeText(zeile);
      setAnzeigeText(spalte);
      anzahl++;
      anzahlLabel.setText(String.valueOf(anzahl));
      boolean fertig=true;
      for(int i=0; i<anz; i++) fertig&=ist[i].getFllung()==soll[i];
      fortschrittLabel.setText(fertig?L_FERTIG:L_WEITER);
    }
  }

  private void setAnzeigeText(int n){
    gieen[n][n].setText(ist[n].toString());
  }

  public static void main(String[] args){
    new KrugSpiel(
      //new Krug[]{new Krug(8,8), new Krug(5,0), new Krug(3,0)},
      //new double[]{4, 4, 0}
      new Krug[]{new See(), new Krug(8,0), new Krug(5,0), new Krug(3, 0)},
      new double[]{Double.POSITIVE_INFINITY, 4, 4, 0}
    );
  }
}
