import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Random;

public class Nimm extends javax.swing.JFrame{
  private int nochda;
  private int max;
  private Random zufall=new Random();

  public Nimm(){
    initComponents();        
  }

  public void weiter(int lass){
    if(nochda<=0) return;
    int nim=nochda-lass;
    if(nim<1)
      status.setText("Nimm mindestens einen der "+nochda+" Steine!");
    else if(nim>max)
      status.setText("Nimm hchstens "+max+" von den "+nochda+" Steinen!");
    else{
      markiere(nim,false);
      nochda=lass;
      if(nochda<=0) status.setText("Du hast gewonnen.");
      else{
        nim=nochda%(max+1);
        if(nim==0) nim=1+zufall.nextInt(3);
        markiere(nim,true);
        nochda-=nim;
        if(nochda==0) status.setText("Ich habe gewonnen.");
        else status.setText("Noch "+nochda+" Steine.");
      }
      repaint();//Beauftragung der Neudarstellung (des Hauptfensters)
    }
  }
  
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
  private void initComponents() {//GEN-BEGIN:initComponents
    wieAnzahlGroup = new javax.swing.ButtonGroup();
    einstell = new javax.swing.JPanel();
    anzPanel = new javax.swing.JPanel();
    wieAnzahl = new javax.swing.JPanel();
    butGenau = new javax.swing.JRadioButton();
    butZufall = new javax.swing.JRadioButton();
    anzahltext = new javax.swing.JTextField();
    maxPanel = new javax.swing.JPanel();
    jLabel1 = new javax.swing.JLabel();
    maxtext = new javax.swing.JTextField();
    newgame = new javax.swing.JButton();
    status = new javax.swing.JLabel();
    anzeige = new javax.swing.JPanel();

    setTitle("Nimm");
    setFont(new java.awt.Font("Default", 1, 12));
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        closeFrame(evt);
      }
    });

    einstell.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

    anzPanel.setLayout(new javax.swing.BoxLayout(anzPanel, javax.swing.BoxLayout.X_AXIS));

    anzPanel.setBorder(new javax.swing.border.TitledBorder("Startanzahl"));
    wieAnzahl.setLayout(new javax.swing.BoxLayout(wieAnzahl, javax.swing.BoxLayout.Y_AXIS));

    butGenau.setFont(new java.awt.Font("Dialog", 0, 10));
    butGenau.setSelected(true);
    butGenau.setText("genau");
    wieAnzahlGroup.add(butGenau);
    wieAnzahl.add(butGenau);

    butZufall.setFont(new java.awt.Font("Dialog", 0, 10));
    butZufall.setText("zuf\u00e4llig bis");
    wieAnzahlGroup.add(butZufall);
    wieAnzahl.add(butZufall);

    anzPanel.add(wieAnzahl);

    anzahltext.setColumns(2);
    anzahltext.setText("20");
    anzPanel.add(anzahltext);

    einstell.add(anzPanel);

    maxPanel.setBorder(new javax.swing.border.TitledBorder("Jeder Spieler nimmt"));
    jLabel1.setFont(new java.awt.Font("Dialog", 0, 10));
    jLabel1.setForeground(java.awt.Color.black);
    jLabel1.setText("mindestens 1, h\u00f6chstens");
    maxPanel.add(jLabel1);

    maxtext.setColumns(2);
    maxtext.setText("3");
    maxPanel.add(maxtext);

    einstell.add(maxPanel);

    newgame.setFont(new java.awt.Font("Dialog", 0, 12));
    newgame.setText("Start");
    newgame.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        newgameActionPerformed(evt);
      }
    });

    einstell.add(newgame);

    getContentPane().add(einstell, java.awt.BorderLayout.NORTH);

    status.setFont(new java.awt.Font("Dialog", 0, 12));
    status.setForeground(java.awt.Color.blue);
    status.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
    status.setText(" ");
    status.setBorder(new javax.swing.border.EtchedBorder());
    getContentPane().add(status, java.awt.BorderLayout.SOUTH);

    anzeige.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        anzeigeMouseClicked(evt);
      }
    });

    getContentPane().add(anzeige, java.awt.BorderLayout.CENTER);

    pack();
    java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
    setSize(new java.awt.Dimension(400, 180));
    setLocation((screenSize.width-400)/2,(screenSize.height-180)/2);
  }//GEN-END:initComponents

	private void closeFrame(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeFrame
        setVisible(false);
        dispose();
        System.exit(0);
	}//GEN-LAST:event_closeFrame

  private void anzeigeMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_anzeigeMouseClicked
    int x=evt.getX();
    int y=evt.getY();
    if(y<Y || y>Y+H) return;
    x=(x-X0+DX-W)/DX;
    if(x<0) x=0;
    if(x>nochda) x=nochda;
    weiter(x);
  }//GEN-LAST:event_anzeigeMouseClicked

    private void newgameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newgameActionPerformed
      try{nochda=Integer.parseInt(anzahltext.getText());}
      catch(NumberFormatException ex){nochda=20;}
      if(butZufall.isSelected()) nochda=10+zufall.nextInt(nochda-9);
      try{max=Integer.parseInt(maxtext.getText());}
      catch(NumberFormatException ex){max=3;}
      init(nochda);
      status.setText("Los geht's mit "+nochda+" Steinen.");
      repaint();
    }//GEN-LAST:event_newgameActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
      new Nimm().show();
    }


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel anzPanel;
  private javax.swing.JRadioButton butZufall;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JTextField anzahltext;
  private javax.swing.JPanel anzeige;
  private javax.swing.JPanel wieAnzahl;
  private javax.swing.JPanel maxPanel;
  private javax.swing.JRadioButton butGenau;
  private javax.swing.ButtonGroup wieAnzahlGroup;
  private javax.swing.JLabel status;
  private javax.swing.JButton newgame;
  private javax.swing.JTextField maxtext;
  private javax.swing.JPanel einstell;
  // End of variables declaration//GEN-END:variables
  private static final int X0=5;
  private static final int DX=10;
  private static final int W=3;
  private static final int Y=5;
  private static final int H=40;
  private Color[] farben;

  public void init(int startAnz){
    farben=new Color[startAnz];
    for(int i=0; i<startAnz; i++) farben[i]=Color.black;
  }

  /* Das hier ist die paint-Methode des HAUPTFENSTERS (ein Nachkomme von
   * JFrame, s.o.). Dass wir sie berschreiben, ist eigentlich hier unan-
   * gemessen, aber wir wollen den gleichen lockeren Luxus, wie ihn Delphi
   * bietet. Mit super.paint(g) sorgen wir dafr, dass alle inneren Kompo-
   * nenten - wie es blich ist - die Mglichkeit bekommen, sich nach eigenem
   * Gutdnken darzustellen, auch das JPanel 'anzeige'. Dieses zeichnet sich
   * ganz grau.
   * Danach holen wir (dh. das HAUPTFENSTER!) uns aber noch einmal gewaltsam
   * die Zeichenflche von 'anzeige' und malen darauf herum. Das steht uns
   * bei sauberem, objektorientiertem Denken nicht zu. In Delphi machen das
   * aber auch alle, und wir wollen uns nicht nachsagen lassen, dass das
   * Programmieren mit Java AN SICH unangenehmer ist, als mit Delphi.
   * (In einem ordentlichen Programm wrde man eine eigene Komponente pro-
   * grammieren, die etwa von JPanel abstammen wrde. DEREN paint-Methode
   * msste man entsprechend berschreiben.)
   */
  public void paint(Graphics g){
    super.paint(g);         //Standardverhalten
    //========== Einstieg in eine seltsame Denkweise =================
    g=anzeige.getGraphics();//Gewaltanwendung, Delphi-Stil, "Canvas" holen
    if(farben==null) return;
    for(int i=0; i<farben.length; i++){
      g.setColor(farben[i]);
      g.fillRect(X0+i*DX,Y,W,H);
    }
    g.dispose();//Resourcenfreigabe; ntig wegen Gewaltanwendung; sonst verboten
    //========== Ende des Bereichs mit der seltsamen Denkweise =======
  }

  public void markiere(int n, boolean rechner){
    Color c=rechner?Color.red:Color.blue;
    for(int i=nochda-n; i<nochda; i++) farben[i]=c;
  }
}
