public class Solitaire{
	/* Backtracking am Beispiel von Solitaire */
  static final int s=15; //Stein (15 als Funktionalitt noch nicht genutzt)
  static final int _=-1; //Rand
  static final int o=0;  //freier Platz
  int[][] felder={//Alle Steine mssen mit _ begrenzt sein!
    {_,_,_,_,_,_},
    {_,_,_,s,s,s,_},
    {_,_,_,s,s,s,_,_},
    {_,s,s,s,s,s,s,s,_},
    {_,s,s,s,o,s,s,s,_},
    {_,s,s,s,s,s,s,s,_},
    {_,_,_,s,s,s,_,_},
    {_,_,_,s,s,s,_},
    {_,_,_,_,_,_}
  };
  int xEnd=4, yEnd=4;//gewnschte Lage des letzten Steins
  int anzahl;//Anzahl der anfangs vorhandenen Steine s wird im Konstruktor ermittelt.
  Zug[] zuege;//Definition siehe Ende der Datei
  /* Alle Angaben erfolgen als (y,x)
     z.B. wird der 5. Zug von (2,3) nach (2,5) so abgespeichert:
     zuege[5].x=2
     zuege[5].y=3
     zuege[5].d='v'
     Die mglichen Zeichen sind <^>v fr links, rauf, rechts, runter
  */
  
  public Solitaire(){
    anzahl=0;
    for(int y=1; y<felder.length-1; y++)
      for(int x=1; x<felder[y].length-1; x++)
        if(felder[y][x]==s) anzahl++;
    zuege=new Zug[anzahl-1];
    for(int i=0; i<anzahl-1; i++) zuege[i]=new Zug();
  }
  
  void versuch(int schritt){
    if(schritt>=anzahl-1 && felder[yEnd][xEnd]==s){
      zuegeAusgabe();
    }
    else{
      for(int y=1; y<felder.length-1; y++) for(int x=1; x<felder[y].length-1; x++){
        if(felder[y][x]==s){
          probOben(y,x,schritt);
          probLinks(y,x,schritt);
          probUnten(y,x,schritt);
          probRechts(y,x,schritt);
        }
      }
    }
  }
  
  void probOben(int y, int x, int schritt){
    if(felder[y-1][x]==s && felder[y-2][x]==o){
      felder[y][x]=o; felder[y-1][x]=o; felder[y-2][x]=s;
      zieheZug(schritt, y, x, '^');
      versuch(schritt+1);
      felder[y][x]=s; felder[y-1][x]=s; felder[y-2][x]=o;
    }
  }
  
  void probUnten(int y, int x, int schritt){
    if(felder[y+1][x]==s && felder[y+2][x]==o){
      felder[y][x]=o; felder[y+1][x]=o; felder[y+2][x]=s;
      zieheZug(schritt, y, x, 'v');
      versuch(schritt+1);
      felder[y][x]=s; felder[y+1][x]=s; felder[y+2][x]=o;
    }
  }
  
  void probLinks(int y, int x, int schritt){
    if(felder[y][x-1]==s && felder[y][x-2]==o){
      felder[y][x]=o; felder[y][x-1]=o; felder[y][x-2]=s;
      zieheZug(schritt, y, x, '<');
      versuch(schritt+1);
      felder[y][x]=s; felder[y][x-1]=s; felder[y][x-2]=o;
    }
  }
  
  void probRechts(int y, int x, int schritt){
    if(felder[y][x+1]==s && felder[y][x+2]==o){
      felder[y][x]=o; felder[y][x+1]=o; felder[y][x+2]=s;
      zieheZug(schritt, y, x, '>');
      versuch(schritt+1);
      felder[y][x]=s; felder[y][x+1]=s; felder[y][x+2]=o;
    }
  }
  
  void zieheZug(int schritt, int y1, int x1, char d){
    zuege[schritt].y=y1-yEnd;
    zuege[schritt].x=x1-xEnd;
    zuege[schritt].d=d;
  }
  
  void zuegeAusgabe(){//hier das einzige mal in der Form (x,y)
    System.out.println("Alle Angaben relativ zum letzten Stein und in der Form (x,y)");
    for(int i=0; i<anzahl-1; i++)
      System.out.println("("+zuege[i].x+","+zuege[i].y+", "+zuege[i].d+" )");
  }
  
  public static void main(String[] args){
    System.out.println("Das wird ein bisschen dauern...");
    Solitaire solitaire=new Solitaire();
    solitaire.versuch(0);
  }
}

/* Zugegeben, das ist eine eigene Klasse. Wir programmieren also "obj", weshalb
 * das Programm in diesem Verzeichnis nichts zu suchen htte. Aber eigentlich
 * handelt es sich nur um das quivalent eines Pascal-Records. Nicht so schlimm,
 * oder?
 */
class Zug{
  int x, y;
  char d;
}
