/* Diese Klasse definiert die Menge der Brche und die Grundrechenarten
 * auf ihnen. Sie ist selber kein lauffhiges Programm (hat keine main-
 * Methode).
*/
public class Bruch{
  private long oben,unten;
  public static final int OBEN=1, UNTEN=2, GANZ=3, REST=4;

  public Bruch(long z,long n){
    oben=z;
    unten=n;
    krzen();
  }
  public Bruch(){this(0,1);}
  public Bruch(long z){this(z,1);}
  public Bruch(Bruch b){
    oben=b.oben;
    unten=b.unten;
  }

  private long ggt(long a,long b){
    a=Math.abs(a); b=Math.abs(b); long c;
    if(a<b){c=a; a=b; b=c;}
    if(b==0) return a;
    do{c=b; b=a%b; a=c;} while(b!=0);
    return a;
  }

  private long kgv(long m, long n){
    long t=ggt(m,n);
    return m/t*n;
  }

  private void krzen(){
    long t=ggt(oben,unten);
    oben=oben/t;
    unten=unten/t;
    if (unten<0){unten*=-1; oben*=-1;}
  }

  public void add(Bruch b){
    long n=kgv(unten,b.unten);
    oben=n/unten*oben+n/b.unten*b.oben;
    unten=n;
    krzen();
  }

  public void mult(Bruch b){
    long m,n; // fr kreuzweises Krzen
    m=ggt(oben,b.unten); n=ggt(unten,b.oben);
    oben=(oben/m)*(b.oben/n);
    unten=(unten/n)*(b.unten/m);
  }

  public void subt(Bruch b){
    long n=kgv(unten,b.unten);
    oben=n/unten*oben-n/b.unten*b.oben;
    unten=n;
    krzen();
  }

  public void div(Bruch b){
    long m,n; // fr kreuzweises Krzen
    m=ggt(oben,b.oben); n=ggt(unten,b.unten);
    oben=(oben/m)*(b.unten/n);
    unten=(unten/n)*(b.oben/m);
  }

  public long   longValue()  {return oben/unten;}
  public int    intValue()   {return (int)(oben/unten);}
  public double doubleValue(){return (double)oben/(double)unten;}
  public float  floatValue() {return (float)doubleValue();}

  public int compareTo(Bruch b){
    Bruch a=new Bruch(this);
    a.subt(b);
    if(a.oben==0) return 0;
    return a.oben>0?1:-1;
  }

  public int compareTo(long n){
    long v=longValue();
    if(v!=n) return v>n?1:-1;
    v=oben%unten;
    if(v==0) return 0;
    return oben>0?1:-1;
  }

  public int compareTo(int n){
    return compareTo((long)n);
  }

  public int compareTo(double d){
    double v=doubleValue();
    if(v==d) return 0;//passiert fast nie
    return v>d?1:-1;
  }

  public int compareTo(float f){
    return compareTo((double)f);
  }

  public String toString(int was){
    String ret_str;
    switch (was){
      case OBEN : ret_str=Long.toString(oben);  break;
      case UNTEN: ret_str=Long.toString(unten); break;
      case GANZ : ret_str=Long.toString((oben-oben%unten)/unten); break;
      case REST : ret_str=Long.toString(oben%unten); break;
      default    : ret_str=toString();
    }
    return ret_str;
  }

  public String toString(){
    return Long.toString(oben)+"/"+Long.toString(unten);
  }
}
