/* Im Gegensatz zu Mastermind denkt sich hier der Rechner nicht die
   Zahlenkombination aus, sondern muss die finden, die der Mensch
   sich ausgedacht hat.
   Dazu bekommt er nach jedem Rateschritt vom Menschen Hinweise. Ein
   Minus bedeutet, dass eine Ziffer richtig erraten wurde, ein Plus auch,
   jedoch ist sie sogar an der richtigen Stelle. Es wird jedoch nicht mitgeteilt,
   welches Zeichen welcher geratenen Ziffer entspricht.
   Erlaubt sind die Ziffern 0 bis 9, jede aber nur einmal.

   Der Algorithmus ist ganz einfach! Der Rechner erzeugt alle mglichen sinn-
   vollen Kombinationen, macht eine solche aber nur dann zur Antwort, wenn sie
   richtig sein kann. Das ist dann der Fall, wenn alle frheren Kombinationen
   zur aktuellen passen, was die Anzahl der Plusse und Minusse angeht.
*/
import java.util.ArrayList;
public class MastermindInvers{
  //die folgenden Variablen drfen gendert werden
  static int grad=4;   //Anzahl der zu erratenden Steine
  static char[] steine={'0','1','2','3','4','5','6','7','8','9'};
  static char plus ='+';//bedeutet "richtiger Stein am richtigen Platz"
  static char minus='-';//bedeutet "richtiger Stein am falschen Platz"

  //die folgenden Variablen sollten nicht gendert werden.
  static ArrayList versuche=new ArrayList(10);;
  static int steineanz=steine.length;
  static int letzte=(int)Math.pow(steineanz,grad)-1;

  /* Die Steine werden anfangs einmal gemischt, damit das Programm nicht immer
     mit der gleichen Kombination zu raten beginnt. Das wre langweilig und fr
     den Menschen ein Weg, schwierige Kombinationen zu stellen.
     Will man das nicht, so kann man das Innere der Methode einfach auskommen-
     tieren.
  */
  private static void mischen(){
    java.util.Random zufall=new java.util.Random();
    for(int i=0; i<steineanz; i++){
      int j=zufall.nextInt(steineanz);
      char c=steine[i];
      steine[i]=steine[j];
      steine[j]=c;
    }
  }

  public static int nchste;
  public static void main(String[] args){
    mischen();
    Versuch aktuell=new Versuch();
    int durchgang=0;
    nchste=-1;
    int m,p;
    weiter: do{
      //erzeuge die nchste Kombination
      nchste++;
      int z=nchste;
      p=m=0;
      //mache aus der Zahl eine gltige Folge von Steinen (falls mglich)
      for(int j=grad-1; j>=0; j--){
        aktuell.tipp[j]=steine[z%steineanz];
        z=z/steineanz;
        //falls Wiederholungen auftreten, nchste Zahl erzeugen
        for(int k=grad-1; k>j; k--)
          if(aktuell.tipp[k]==aktuell.tipp[j]) continue weiter;
      }
      //die aktuelle Folge darf nicht im Widerspruch zu den bisherigen stehen
      for(int j=0; j<durchgang; j++)
        if(!aktuell.passtZu((Versuch)versuche.get(j))) continue weiter;
      //Antwort einholen und auswerten
      versuche.add(aktuell);
      System.out.print(++durchgang+". Versuch: "+aktuell+"  ");
      String antwort=LineInput.readString();
      for(int i=0; i<antwort.length(); i++){
        if(antwort.charAt(i)==plus)  p++;
        else if(antwort.charAt(i)==minus) m++;
      }
      aktuell.plusse =p;
      aktuell.minusse=m;
      aktuell=new Versuch();
      if(nchste>=letzte){
        System.out.println("Sie haben widersprchliche Angaben gemacht.");
        System.exit(1);
      }
    } while(p<grad);
  }

  static class Versuch{
    char[] tipp=new char[grad];
    int plusse;
    int minusse;

    public boolean passtZu(Versuch v){
      int p=0;
      int m=0;
      for(int i=grad-1; i>=0; i--)
        for(int j=grad-1; j>=0; j--)
          if(v.tipp[i]==tipp[j])
            if(i==j) p++; else m++;
      return p==v.plusse && m==v.minusse;
    }

    public String toString(){
      StringBuffer sb=new StringBuffer(grad);
      for(int i=0; i<grad; i++) sb.append(tipp[i]);
      return sb.toString();
    }
  }
}
