import java.awt.*;
import javax.swing.*;
/* Zeichnet das gleiche Moiree-Muster wie Moiree.java, aber in einer modernen
 * Swing-Komponente. Das Programm ist ordentlich beendbar.
 */
public class Moiree2 extends JComponent{
  Color farbe;

  public Moiree2(Color c){
    farbe=c;
    setPreferredSize(new Dimension(150,150));
    //setOpaque(false); Standardeinstellung bei JComponent
  }
  
  public void setFarbe(Color c){
    farbe=c;
  }

  public void paintComponent(Graphics g){
    g.setColor(farbe);
    int breit=getWidth();
    int tief=getHeight();
    for(int i=0; i<breit; i+=10){
      g.drawLine(0,     0,    i, tief);
      g.drawLine(breit, tief, i, 0   );
    }
    for(int i=0; i<tief; i+=10){
      g.drawLine(0,     0,    breit, i);
      g.drawLine(breit, tief, 0,     i);
    }
  }
  
  public static void main(String[] args){
    JFrame f=new JFrame("main von Moiree2.java");
    f.setDefaultCloseOperation(f.EXIT_ON_CLOSE);
    Container c=f.getContentPane();
    c.add(new Moiree2(Color.blue),BorderLayout.CENTER);
    f.pack();
    f.show();
  }
}
