import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

/* Dieses Programm ist ein Applet, besitzt aber auch eine main-Methode
 * und ist damit als eigenstndiges Programm einsetzbar.
 * Es wandelt Zahlen von einer Basis in die andere um.
*/
public class ZahlenBasis extends Applet implements ActionListener, WindowListener{
  TextField eingabe;
  TextField eingabebasis;
  Label     ausgabe;
  TextField ausgabebasis;
  Button rechne;

  public ZahlenBasis(){
    aufbau(this);
  }

  public void aufbau(Container c){
    eingabe=new TextField("0",10);
    c.add(eingabe);
    Panel p=new Panel(new GridLayout(2,1));
    c.add(p);
    p.add(new Label("Basis"));
    eingabebasis=new TextField("10",2);
    p.add(eingabebasis);
    rechne=new Button("Umwandeln");
    rechne.addActionListener(this);
    c.add(rechne);
    ausgabe=new Label("                                                                                0");
    c.add(ausgabe);
    p=new Panel(new GridLayout(2,1));
    c.add(p);
    p.add(new Label("Basis"));
    ausgabebasis=new TextField("16",2);
    p.add(ausgabebasis);
  }

  public void actionPerformed(ActionEvent e){
    int b1=getNumber(eingabebasis.getText(), 10);//Basen immer dezimal
    int b2=getNumber(ausgabebasis.getText(), 10);
    if(b1<2 || b2<2 || b1>36 ||b2>36){
      ausgabe.setText("ungltige Basis");
      return;
    }
    int i1=getNumber(eingabe.getText(), b1);
    ausgabe.setText(Integer.toString(i1, b2));
  }

  public int getNumber(String wert, int basis){
    int ret;
    try{ret=Integer.parseInt(wert, basis);}
    catch(NumberFormatException ex){ret=0;}
    System.out.println(ret);
    return ret;
  }

  public void windowClosing(WindowEvent e){System.exit(0);}
  //Die folgenden Methoden sind leer, weil sie nichts tun mssen.
  //Sie mssen aber aufgefhrt werden, damit die Klasse selber
  //WindowListener sein kann. Hier wurde der Weg der Adapterklasse
  //nicht gegangen. Bitte im Tutorial nachlesen!
  public void windowActivated(WindowEvent e){}
  public void windowClosed(WindowEvent e){}
  public void windowDeactivated(WindowEvent e){}
  public void windowDeiconified(WindowEvent e){}
  public void windowIconified(WindowEvent e){}
  public void windowOpened(WindowEvent e){}

  public static void main(String[] args){
    Frame f=new Frame("Basiskonverter");
    ZahlenBasis zb=new ZahlenBasis();
    f.addWindowListener(zb);
    Panel p=new Panel();
    f.add(p);
    zb.aufbau(p);
    f.pack();
    f.show();
  }
}
