/** Diese Klasse stellt fr andere Klassen Befehle zur Eingabe von der
 * Konsole bereit. Der Programmtext muss Schlern nicht erklrt
 * werden. Es reicht, die .class-Datei zu haben und die Funktionalitt
 * zu verstehen.
*/
public class LineInput{
  public static final int OK         =0;
  public static final int STRINGERROR=0x80000000;
  public static final int DOUBLEERROR=2;
  public static final int FLOATERROR =3;
  public static final int LONGERROR  =4;
  public static final int INTERROR   =5;
  
  private static String errmsg="";
  private static int status;
  
  /** greift auf die Standardeingabe zu.
   */
  private static java.io.BufferedReader rein=
    new java.io.BufferedReader(new java.io.InputStreamReader(System.in));

  /** gibt die letzte Fehlermeldung wieder
   */
  public static String lastError(){return errmsg;}
  
  /** wartet auf eine Eingabe von der Konsole und gibt sie als String
   * zurck. Im Fehlerfall wird ein leerer String zurck gegeben.
   */
  public static String readString(){
    status=OK;
    String st;
    try{
      st=rein.readLine();
    }catch (java.io.IOException e){
      st="";//leerer String im Fehlerfall
      errmsg="Fehler beim Einlesen eines Strings";
      status=STRINGERROR;
    }
    return st;
  }

  /** wartet auf eine Eingabe von der Konsole und gibt sie als double
   * zurck. Im Fehlerfall wird 0.0 zurck gegeben.
   */
  public static double readDouble(){
    String st=readString();
    try{
      return Double.parseDouble(st);
    }catch (NumberFormatException e){
      errmsg="Ungltige Fliekommazahl";
      status=DOUBLEERROR;
      return 0;
    }
  }

  /** wartet auf eine Eingabe von der Konsole und gibt sie als float
   * zurck. Im Fehlerfall wird 0.0 zurck gegeben.
   */
  public static float readFloat(){
    if(status==DOUBLEERROR) status=FLOATERROR;
    return (float)readDouble();  
  }

  /** wartet auf eine Eingabe von der Konsole und gibt sie als long
   * zurck. Im Fehlerfall wird 0 zurck gegeben.
   */
  public static long readLong(){
    String st=readString();
    try{
      return Long.parseLong(st);
    }catch (NumberFormatException e){
      errmsg="Ungltige Ganzzahl";
      status=LONGERROR;
      return 0;
    }
  }

  /** wartet auf eine Eingabe von der Konsole und gibt sie als int
   * zurck. Im Fehlerfall wird 0 zurck gegeben.
   */
  public static int readInt(){
    if(status==LONGERROR) status=INTERROR;
    return (int)readLong();
  }
  
  /** Dient nur Zestzwecken. Hat an sich keinen Sinn.*/
  public static void main(String[] args){
    String s=readString(); System.out.println(s);
    int    i=readInt();    System.out.println(i);
    long   l=readLong();   System.out.println(l);
    float  f=readFloat();  System.out.println(f);
    double d=readDouble(); System.out.println(d);
  }
}
