/* Dieses Programm durchsucht long-Zahlen im Bereich [von; bis[
   nach Primzahlzwillingen und nutzt dafr alle Rechner, die als
   ArbeitsSuchende zur Verfgung stehen. Die in Frage kommenden Rechner
   werden als Parameter angegeben. Beispiel:

     java PSucheZwillinge 2 2000000 192.168.1.3 lothar 192.168.1.117:1278

   versucht, drei Rechner einzusetzen. 192.168.1.3 und lothar werden
   auf dem Standardport 1099 gefragt, 192.168.1.117 auf Port 1278.
   Durchsucht werden die Zahlen 2 bis einschlielich 1999999.

   Aufpasser werden eingesetzt, weil sonst bei der Vergabe des Jobs
   schon auf dessen Ergebnis gewartet werden msste. Das wrde keinen
   zeitlichen Vorteil bringen.
   Wenn ein Aufpasser die Ergebnisse bringt, werden diese einfach
   ausgegeben. Damit nicht ein zweiter Aufpasser ebenfalls in die
   Ausgaberoutine springt, whrend der erste noch drin ist, muss die
   Ausgaberoutine synchronized sein.
 */
import java.rmi.*;

public class PSucheZwillinge implements Aufpasser.Interessent{
  //Die folgende Methode muss implementiert werden, um Aufpasser.Interessent
  //sein zu knnen.
  public synchronized void nimmErgebnis(Object obj){
    Object[] zwilli1=(Object[])obj;
    for(int i=0; i<zwilli1.length; i++){
      long z=((Long)zwilli1[i]).longValue();
      System.out.print(z+","+(z+2)+"  ");
    }
    System.out.println();
  }

  public static void main(String args[]){
    if(args.length<3){
      System.out.println("Aufruf:\n"+
        "java PSucheZwillinge von bis ip1 ip2 ip3 ip4 ...");
      System.exit(1);
    }
    try{
      //Bestimme den zu durchsuchenden Bereich
      long von=Long.parseLong(args[0]);
      long bis=Long.parseLong(args[1]);
      System.out.println("Die folgenden Zahlen sind Zwillinge:");
      //teste, wie viele der angegebenen IPs einen Arbeiter anbieten;
      //diese vorne in args sammeln
      int anz=0;
      for(int i=2; i<args.length; i++)
        if(ArbeitsSuchend.isArbeitssuchend(args[i])) args[anz++]=args[i];
      //Ein Interessent nimmt alle Ergebnisse entgegen
      Aufpasser.Interessent ai=new PSucheZwillinge();
      //Bereich auf mehrere Aufpasser (mit Arbeitern) verteilen
      Job job;
      long menge=(bis-von)/anz+1;//Anzahl der von jedem Job zu bearbeitenden Zahlen
      while(von<bis){
        long grenze=von+menge;
        if(grenze>bis) grenze=bis;
        job=new JSucheZwillinge(von, grenze);
        von=grenze;
        //Der Aufpasser holt sich selber einen Arbeiter.
        new Aufpasser(job, args[--anz], ai);
      }
    } catch(Exception e){
      System.out.println (e.getMessage());
      e.printStackTrace ();
    }
  }
}
