/** Stellt Zugriff auf ein Array von ganzen Zahlen zur Verfgung,
 * die von einem Sortieralgorithmus sortiert werden sollen.
 */
public interface Demonstrator{
  /**
   * benimmt die zu sortierende Zahlenmenge. Wird <CODE>null</CODE> bergeben,
   * stellt der Demonstrator eine Default-Zahlenmenge zur Verfgung.
   * @param zahlen ebendiese.
   */
  void nimmZahlen(int[] zahlen);
  /**
   * wirbelt die Zahlenmenge durcheinander, ohne die Zahlen zu verndern.
   */  
  void mischen();
  /**
   * gibt eine der Zahlen aus der Menge zurck und zhlt dieses
   * Ereignis mit. Eine Verzgerung wird auch erzeugt.
   * @param index der Index in der Zahlenmenge.
   * @return die Zahl an der betreffenden Stelle.
   */  
  int gibZahl(int index);
  /**
   * vertauscht zwei Zahlen aus der Zahlenmenge und zhlt dieses
   * Ereignis mit. Eine Verzgerung wird auch erzeugt.
   * @param index1 Index der einen Zahl.
   * @param index2 Index der zweiten Zahl.
   */  
  void vertauscheZahlen(int index1, int index2);
  /**
   * markiert einen Index. Das ist kein Attribut der Zahl, die dort abgelegt
   * ist, sondern ein Attribut der Position. Bei Vertauschungen wird die
   * Markierung also nicht mitgetauscht.
   * @param index die zu markierende Position in der Zahlenmenge.
   * @param wie wenn mehrere Arten der Markierung (z.B. Farben) mglich
   * sind, kann mit diesem Argument eine davon ausgewhlt werden.
   */  
  void markierePlatz(int index, int wie);
  /**
   * gibt die Anzahl der bisher gettigten Zugriffe in die Zahlenmenge
   * wieder.
   * @return ebendiese.
   */  
  int anzZugriffe();
  /**
   * gibt die Gre der zu sortierenden Zahlenmenge zurck.
   * @return ebendiese.
   */
  int anzahl();
  /**
   * gibt die Anzahl der bisher gettigten Vertauschungen wieder.
   * @return ebendiese.
   */  
  int anzVertauschungen();
  /**
   * verlangsamt alle Vorgnge um einen Faktor.
   * @param faktor der Faktor mit dem verlangsamt wird.
   */
  void verlangsame(int faktor);
  /**
   * stellt die Zahlenmenge im aktuellen Zustand dar und gibt als Ergebnis
   * zurck, ob die Menge korrekt sortiert ist.
   * @return true, wenn die Menge korrekt sortiert ist, anderenfalls false
   */  
  boolean korrekt();
}
