import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Dieses Applet stellt mit Hilfe eines StabDemonstrators einen
 * Sortieralgorithmus dar. Dieser kann als Parameter bergeben werden.
 */
public class SortApplet extends JApplet implements ActionListener{
  /**
   * der verwendete Stabdemonstrator.
   */  
  StabDemonstrator demo;
  /**
   * der darzustellende Algorithmus.
   */  
  Algorithmus alg;
  /**
   * eine Statuszeile, die anfangs den Namen des Algorithmus und am Ende
   * die Anzahl der Zugriffe und Vertauschungen anzeigt.
   */  
  JLabel status;
  /**
   * zeigt den Verlangsamungsfaktor an.
   */  
  JTextField langsam;
  /**
   * beinhaltet den Namen des Algorithmus.
   */  
  String name;

  /**
   * Erzeugt die Oberflche mit den Buttons fr das Mischen, Sortieren
   * und die Geschwindigkeitseinstellung. Der Algorithmus wird dynamisch
   * erzeugt, weil als Parameter bergeben. Fr die Darstellung wird
   * ein Stabdemonstrator verwendet.
   */  
  public void init(){
    Container c=getContentPane();
    JPanel p=new JPanel();
    JButton b=new JButton("mischen");
    b.addActionListener(this);
    p.add(b);
    b=new JButton("sortieren");
    b.addActionListener(this);
    p.add(b);
    status=new JLabel("Verlangsamung ");
    p.add(status);
    langsam=new JTextField("1",3);
    p.add(langsam);
    c.add(p,BorderLayout.SOUTH);
    demo=new StabDemonstrator();
    c.add(demo, BorderLayout.CENTER);
    name=getParameter("name");
    try{alg=(Algorithmus)Class.forName(name).newInstance();}
    catch (Exception e){
      name="InsertionSort";
      alg=new SelectionSort();
    }
    status=new JLabel(name);
    c.add(status, BorderLayout.NORTH);
    alg.setDemonstrator(demo);
    demo.nimmZahlen(alg.macheZahlen(1, 51, 50,false));
  }

  /**
   * reagiert auf das Drcken der Buttons.
   * @param e wird nur verwendet, um zu erfahren, welcher Button diesen
   * Event verursacht hat.
   */  
  public void actionPerformed(ActionEvent e){
    if(e.getActionCommand().startsWith("m")){
      demo.mischen();
      status.setText(name);
    } else{
      int f;
      try{f=Integer.parseInt(langsam.getText());}
      catch(Exception ex){f=1;}
      demo.verlangsame(f);
      Thread t=new Thread(){
        public void run(){
          alg.sortiere();
          status.setText(demo.anzZugriffe()+" Lesezugriffe und "
            +demo.anzVertauschungen()+" Vertauschungen; "
            +(demo.korrekt()?"sortiert.":"unsortiert"));
        }
      };
      t.start();
    }
  }
  
  /**
   * Ein Applet gibt Auskunft ber sich durch diese Methode.
   * @return die Auskunft
   */  
  public String getAppletInfo() {
    return "Franz Beslmeisl, in Abwandlung eines Demo-Applets von Sun:"
     +"\nDieses Applet demonstriert Sortieralgorithmen.";
  }

  /**
   * Hier wird Auskunft gegeben ber die Parameter.
   * @return die Auskunft
   */  
  public String[][] getParameterInfo() {
    String[][] info={
      {"name", "string", "Name der Klasse mit dem Sortieralgorithmus."},
    };
    return info;
  }
}
